/*
 * GEMClip, a Clipboard Manager for FreeMiNT and MagiC.
 *
 * Copyright (C) 2011 Jean-Franois Lemaire (jflemaire@skynet.be)
 *
 * This file is part of GEMClip.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* No menubar for MagiC. */
#define MINTATTRIBS  ( NAME | INFO | FULLER | MENUBAR | CLOSER | MOVER | SMALLER | BORDER )
#define MAGICATTRIBS ( NAME | INFO | FULLER | CLOSER | MOVER | SMALLER )

/* Mouse/Keyboard Actions Constants. */
enum { ACTN_MENU = 1, ACTN_CURRENT = 2, ACTN_INFO = 3, ACTN_VIEW = 4 }; // Same as popup menu items.

int  open_manager          (GEMCLIP *manager, USERCONF *conf);
void handle_manager        (GEMCLIP *manager, USERCONF *conf, EVMULT_IN *evmult_in, EVMULT_OUT *evmult_out, short object, BUBBLES *bubbles);
int  handle_selection      (GEMCLIP *manager, short object, EVMULT_OUT *evmult_out);
void update_listbox        (GEMCLIP *manager);
void update_listbox_slots  (GEMCLIP *manager);
void write_date_info       (char *str, CLIPS *clips, int dformat, int datesep, const char *bytes, int txtlen);
void update_clips_infoline (GEMCLIP *manager);
void update_indices        (CLIPS *clips[], int topclip, OBJECT *tree, short handle);
void update_bottom_preview (OBJECT *tree, const char *preview);
void set_listbox_order     (GEMCLIP *manager, USERCONF *conf);
void update_preview        (GEMCLIP *manager);
void update_objects        (GEMCLIP *manager);
void clear_manager         (GEMCLIP *manager);
int  resize_manager        (GEMCLIP *manager, int item, USERCONF *conf);
void update_icon_preview   (GEMCLIP *manager);
