/*
 * GEMClip, a Clipboard Manager for FreeMiNT and MagiC.
 *
 * Copyright (C) 2011 Jean-Franois Lemaire (jflemaire@skynet.be)
 *
 * This file is part of GEMClip.
 *
 * This program is free software; redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include <stdlib.h>
#include <stdio.h>
#include <mint/cookie.h>
#include <mint/osbind.h>

#include "general.h"
#include "about.h"
#include "print.h"

/*
 * Print clips via GDOS.
 */
void print_clips(GEMCLIP *manager)
{
	long cookie   = 0;

	if (Getcookie(C_FSMC, &cookie) == C_FOUND)
	{
		if (Cprnos() == DEV_READY)
		{
			char fname[MBUFFER] = {0};
			char dname[MBUFFER] = {0};
			short foo	  = 0;
			short printer = 0;
			short workin[11];
			short workout[57];
			short device  = DEV_MISSING;
			int width     = 0;
			int height    = 0;

			workin[0] = 21;
			for (int i = 1; i < 10; workin[i++] = 1) { ; }
			workin[10] = 2;
			v_opnwk(workin, &printer, workout);
			
			if (printer != 0)
			{
				width = workout[0];
				height = workout[1];
	
				vq_devinfo(printer, 21, &device, fname, dname);
	
				/*if (device == DEV_INSTALLED)
				{*/
					short clip[4];
					short x, y, w, h;
					
					vst_load_fonts(printer, 0);
					v_clear_disp_list(printer);
	
					clip[0] = 0;
					clip[1] = 0;
					clip[2] = width;
					clip[3] = height;

					vs_clip(printer, TRUE, clip);
					vswr_mode (printer, MD_TRANS);
					vst_alignment(printer, 1, 5, &foo, &foo);
					vst_color(printer, 1);
					x = width / 2;
					y = 200;
					vst_font(printer, 1);
					vst_arbpt(printer, 10, &foo, &foo, &w, &h);
	
					for (int i = 0; (i <= manager->text->nolines) && (y < height); i++)
					{
						v_ftext(printer, x, y, manager->text->line[i]);
						y += h;
					}
	
					vs_clip(printer, FALSE, clip);
					v_updwk(printer); // Print.
					v_clrwk(printer); // Eject.
					Bconin(2);
	
					vst_unload_fonts(printer, 0);
					v_clswk(printer);
				/*}
				else {
					form_alert(1, FA_ERROR "[Driver not installed.][OK]");
				}*/
			}
			else {
				form_alert(1, FA_ERROR "[Error while opening printer|workstation.][OK]");
			}
		}
	}
}
