/*
 * GEMClip, a Clipboard Manager for FreeMiNT and MagiC.
 *
 * Copyright (C) 2011 Jean-Franois Lemaire (jflemaire@skynet.be)
 *
 * This file is part of GEMClip.
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

/* BubbleGEM Indices */
enum { MGRCURR,
       MGRVIEW,
       MGRSAVE,
       MGRDELE,
       MGRMODE,
       MGRTEXT,
       MGRINFO,
       MGRNAME,
       MGRDATE,
       MGRSIZE,
       MGRORDR,
       MGRICON,
       MGRSCRP,
       MGRLIST,
       MGRPREV,
       
       ABTOKAY,
       ABTSITE,
       ABTHELP,
       
       CNFMISC,
       CNFKEYS,
       CNFLIMT,
       CNFICON,
       CNFAUTO,
       CNFSETT,
       CNFCYCL,
       CNFBUBL,
       CNFMPTY,
       CNFWRNG,
       CNFDBCK,
       CNFRIGT,
       CNFRTRN,
       CNFSPAC,
       CNFINSR,
       CNFSIZE,
       CNFCLIP,
       CNFFREE,
       CNFPATH,
       CNFOVER,
       CNFOKAY,
       CNFCNCL,
       CNFAPLY,
       CNFDFLT,
       CNFHELP,
       
       INFPREV,
       INFNEXT,
       INFHELP };

enum { BUBBLEGEM_REQUEST = (short)0xBABA,
       BUBBLEGEM_SHOW    = (short)0xBABB,
       BUBBLEGEM_ACK     = (short)0xBABC,
       BUBBLEGEM_ASKFONT = (short)0xBABD,
       BUBBLEGEM_FONT    = (short)0xBABE,
       BUBBLEGEM_HIDE    = (short)0xBABF };

/* AV */
int  init_av_protokoll           (int os, char *name);
void av_protokoll_exit           (const char *server);
void av_protokoll_window         (short handle, const char *server, int message);
void av_protokoll_send_key       (const char *server, short kreturn);
void av_protokoll_open_file      (const char *path, int size, const char *command, const char *server, int system);
void av_protokoll_delete_file    (const char *path, int size, const char *server);
void update_desktop_window       (char *path, const char *avserver, int os);
void av_protokoll_path_update    (const char *server, const char *path, int os);
void av_protokoll_clipbrd_update (const char *server);
void av_protokoll_send_message   (const char *server, short msg[]);

/* BubbleGEM */
int  init_bubbles         (struct bubbles *bubl, int aeslang, int os);
void free_bubbles         (struct bubbles *bubl, USERCONF *conf);
void display_bubble_mouse (struct bubbles *bubl, int idx, short xpos, short ypos, USERCONF *conf);
void update_infoline      (GEMCLIP *manager, WINDOW *win, OBJECT *tree, BUBBLES *bubbles, short object);
